# WSO2 Microservices Framework for Java (MSF4J) Samples

This directory contain a comprehensive suite of samples demonstrating the capabilities of WSO2 MSF4J.

# Requirements
* JDK 1.8.*
* Maven 3.0.x

#Samples 
In increasing order of complexity;

* [Hello World](helloworld) - Running a basic Microservice
* [Spring Hello World](spring-helloworld) - Running a basic Microservice using the Spring framework  
* [StockQuote (Fat jar)](stockquote/stockquote-fatjar) - Developing a Microservice as a single jar which packs all the dependencies
* [StockQuote (OSGi bundle)](stockquote/stockquote-bundle) - Creating a Microservice as an OSGi Bundle
* [Lifecycle](lifecycle) - Using Service Lifecycle Methods
* [Metrics](metrics) - Using Metrics Interceptor
* [HTTP Monitoring](http-monitoring) - Using HTTP Monitoring Interceptor
* [Regex PathParam](regex-pathparam) - How to use regex with PathParam annotation
* [File Server](fileserver) - Handling Files including streaming input & output
* [FormParam](formparam) - Shows usage of the FormParam annotation
* [Circuit Breaker](circuitbreaker) - Using the circuit breaker pattern
* [Log-interceptor](log-interceptor-bundle) - Creating an Interceptor as an OSGi Bundle
* [BasicAuth Security](basicauth-security) - Securing Microservice using BasicAuth
* [OAuth2 Security](oauth2-security) - Securing Microservice using OAuth2
* [Template](template) - Rendering a Model from a Template
* [Pet-store](petstore) - Running as an MSA Application
* [Hello World JPA](helloworld-JPA) - Simple JPA Hibernate based sample

